#!BPY

""" Registration info for Blender menus
Name: 'projection painting tool'
Blender: 243
Group: 'Misc'
Tip: 'paint-tools'
"""

import Blender as B
from Blender import Window,Image, Object, Scene, Material,Texture,Draw,Mathutils,Mesh
from Blender.Draw import *
from Blender.Mathutils import *
#from Blender.BGL import *
#import bpy
#import BPyMesh

#scn= B.Scene.GetCurrent()
#scn_objects = scn.objects
#ob= scn_objects.active
scn= B.Scene.GetCurrent()
scn_objects = scn.objects
ob= scn_objects.active
width=512;
height=512;
paintlayer=None;
mesh=ob.getData(mesh=1)
origimage=None;
origUVLayer=''
uvs=[]
origmats=[]
for f in mesh.faces:
	uvs.append(f.uv)


def paintmat(origimage,paintlayer):
	global origUVLayer;
	mat=Material.New();
	mat.setMode('Shadeless')

	
	texbase=Texture.New()
	texbase.setType('Image')
	texbase.setImage(origimage)
	co=Texture.TexCo.UV
	mat.setTexture(0,texbase,co)
	mat.getTextures()[0].uvlayer=origUVLayer	
	#
	tex=Texture.New()
	tex.setType('Image')
	tex.setExtend('Clip')
	tex.setImage(paintlayer)
	#tex.calcAlpha=True;
	co=Texture.TexCo.UV
	mat.setTexture(1,tex,co)
	mat.getTextures()[1].uvlayer='paint'
	return mat

#def mergeimages(img1,img2):

def preparepaint():
	
	global width, height,paintlayer,origimage,origUVLayer,origmats,uvs
	#wildp ('xxx')
	origmats=mesh.materials
	#wildp ('befori')
	#print dir(mesh)
	#print dir(B.Image)
	origUVLayer=mesh.activeUVLayer
	origimage=mesh.faces[0].image
	width,height=origimage.getMaxXY()

	#paintlayer=B.Image.Get('p_layer')
	#if paintlayer==None:
	paintlayer=B.Image.New('p_layer',width/2,height/2,32)
		
	#paintlayer = B.Image.Get('p_layer')
	pwidth,pheight=paintlayer.getMaxXY()
	paintlayer.pack()
	for x in range(0,pwidth):
		for y in range(0,pheight):
			paintlayer.setPixelF(x,y,[0,0,0,0])
	paintlayer.getDepth()
	

	print paintlayer.getDepth()
	
	
	mat=paintmat(origimage, paintlayer)
	
	
	mesh.materials=[mat]
	uvlayers=mesh.getUVLayerNames()
	
	if 'paint' in uvlayers:
		mesh.removeUVLayer('paint')
	mesh.addUVLayer('paint')
	mesh.activeUVLayer = 'paint'
	mesh.renderUVLayer = ('paint')
	
	#print mesh.faces[1].uv
	viewLoc = Window.GetViewVector	()
	#viewLoc[0]=viewLoc[0]*1000
	#viewLoc[1]=viewLoc[1]*1000
	#viewLoc[2]=viewLoc[2]*1000	
	vmat= Window.GetViewMatrix()
	omat = Matrix(ob.getMatrix())
	uvmat = vmat * omat
	uvmat.transpose()
	omat.transpose()
	B.Mesh.Mode(Mesh.SelectModes['FACE'])
	
	uvminx=10000.0
	uvminy=10000.0
	uvmaxx=-10000.0
	uvmaxy=-10000.0
	for f in mesh.faces:
		f.image=paintlayer
		f.uv =tuple([ Mathutils.Vector(-10.0,-10.0) for uv in f.uv])
		#f.sel = 0
		normal = omat.rotationPart() * Vector(f.no)
		max_len = 0
		for vect in f:
			point = Vector(vect.co)
	 		point = omat * point.resize4D()
			point.resize3D()
			vv = Vector(viewLoc) - point
			if vv.length > max_len:
				max_len = vv.length
				view_vect = vv
		i=0
		
		d = view_vect * normal
		if d>0:
			#f.sel=1	
			uv=[]
			for a in range(0,len(f.uv)):
				point = Vector(f.v[i].co)
				point = uvmat * point.resize4D()
				point.resize3D()
				#print point
				uv.append(Vector(point[0],point[1]))
				i+=1
				if point[0]<uvminx: uvminx=point[0]
				elif point[0]>uvmaxx: uvmaxx=point[0]
				if point[1]<uvminy: uvminy=point[1]
				elif point[1]>uvmaxy: uvmaxy=point[1]
			#print(uv[a] for a in range(0,len(f.uv)))
			f.uv=([uv[a] for a in range(0,len(f.uv))])
	#scaling uv
	print uvmaxx,uvmaxy,uvminx,uvminy
	uvw=uvmaxx-uvminx
	uvh=uvmaxy-uvminy

	for f in mesh.faces:
		f.uv = tuple([ Mathutils.Vector((uv[0]-uvminx)/uvw,(uv[1]-uvminy)/uvh) for uv in f.uv])
	#oldmode = Mesh.Mode()
	
			
	#print mesh.faces[1].uv
			
	# here shall go teh wicked projection;		
	#viewmatrix=Window.GetPerspMatrix()
	#obmatrix=ob.getMatrix
	#viewmatrix * obmatrix
	mesh.update()

	
	

def applypaint():
	print origUVLayer
	global mesh,origimage,paintlayer,origUVLayer,width,height,origmats,uvs;
#	mesh.activeUVLayer = origUVLayer
#	mesh.addUVLayer('bake')
	mesh.activeUVLayer =origUVLayer
	mesh.renderUVLayer =origUVLayer
	mesh.update
	#i=0
	#for f in mesh.faces:
	#	f.image=paintlayer
	#	f.uv=uvs[i]
	#	i+=1
	bakeimage=B.Image.New('bakedpaint',width,height,origimage.getDepth())
	for f in mesh.faces:
		f.image=bakeimage
	renderc=scn.getRenderingContext()

	renderc.bakeMode=(Scene.Render.BakeModes.TEXTURE)
	renderc.bakeMargin=2;
	renderc.bakeClear=True;
	renderc.bakeToActive=False;
	print 'baking'
	renderc.bake()	
	print 'merging images'

	#copy image to original
	for x in range(0,width):
		for y in range(0,height):
			newp=bakeimage.getPixelF(x,y)
			origimage.setPixelF(x,y,newp)
	
	deletepaint();

def deletepaint():
	global mesh,origmats,origimage;
	for f in mesh.faces:
		f.image=origimage
	mesh.removeUVLayer('paint')
	mesh.activeUVLayer =origUVLayer
	mesh.renderUVLayer =origUVLayer
	mesh.materials=origmats;
	mesh.update

EVENT_PREPARE=1
EVENT_APPLY=2
EVENT_DELETE=3
EVENT_EXIT=4
def draw():
	global width, height
	global EVENT_PREPARE, EVENT_APPLY
	Button("Prepare paint layer",EVENT_PREPARE,10,100,280,25)
	Button("Apply paint layer",EVENT_APPLY,10,70,280,25)
	Button("Delete paint layer(no apply)",EVENT_DELETE,10,40,280,25)
	
	Button("Exit",EVENT_EXIT,210,10,80,20)
	
def event(evt, val):
	if ((evt == QKEY or evt == ESCKEY) and not val): Exit()
		
def pevent(evt):
	if evt == EVENT_EXIT		: Exit()
	elif evt == EVENT_PREPARE	: preparepaint()
	elif evt == EVENT_APPLY	: applypaint()
	elif evt == EVENT_DELETE : deletepaint()
	
Register(draw, event, pevent)

